////////////////////////////////////////////////////////////////////////
// playlist.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.playlist")

// <%pre>
#line 1 "playlist.ecpp"


#include <setup.h>
#include <tools.h>
#include <users.h>

using namespace std;
using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class m3u_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        m3u_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    m3u_type m3u;
};

static tnt::ComponentFactoryImpl<_component_> Factory("playlist");

static const char* rawData = "\024\000\000\000\025\000\000\000\026\000\000\000\027\000\000\000\030\000\000\000\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    m3u(*this, "m3u")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("playlist " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
tChannelID channel = tnt::stringTo<tChannelID>("channel", "tChannelID", qparam.param("channel"), reply.out().getloc());
string recid = tnt::stringTo<string>("recid", "string", qparam.param("recid"), reply.out().getloc());
  // </%args>

#line 16 "playlist.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 19 "playlist.ecpp"
  typedef cChannel* Channel_type;
  TNT_REQUEST_PAGE_VAR(Channel_type, Channel, "cChannel* Channel", ());   // <%request> cChannel* Channel
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 22 "playlist.ecpp"

	if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");
	if (!cUser::CurrentUserHasRightTo(UR_STARTREPLAY))
		throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );

    // the availabilty of Channel signals that we will do live tv streaming.
	Channel = 0;
	if (recid.empty()) {
#if VDRVERSNUM >= 20301
		LOCK_CHANNELS_READ;
		Channel = (cChannel *)Channels->GetByChannelID(channel);
#else
		ReadLock channelsLock(Channels);

		if (!channelsLock) {
			throw HtmlError(tr("Couldn't aquire access to channels, please try again later."));
		}
		Channel = Channels.GetByChannelID(channel);
#endif
		if (Channel == 0) {
			throw HtmlError( tr("Couldn't find channel or no channels available. Maybe you mistyped your request?") );
		}
	}
	string server = request.getHost();
	server = server.substr(0, server.rfind(':'));
	string videourl;
	reply.setContentType("application/vnd.apple.mpegurl");
	if (Channel != 0) {
		string channelname = Channel->Name();
		int streamdevPort = LiveSetup().GetStreamdevPort();
		videourl = string("#EXTM3U\n#EXTINF:-1,") + channelname + "\nhttp://" + server + ":" + lexical_cast<string,int>(streamdevPort) + "/" + LiveSetup().GetStreamdevType() + "/" + *Channel->GetChannelID().ToString();
	}
	else {
		videourl = string("#EXTM3U\n#EXTINF:-1\nhttp://") + server + ":" + lexical_cast<string,int>(LiveSetup().GetServerPort()) + "/recstream.html?recid=" + recid;
	}

  // <& playlist.m3u ...
  { 
#line 58 "playlist.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 58 "playlist.ecpp"
    _tnt_cq0.add( "videourl", tnt::toString((videourl), reply.out().getloc() ) );
#line 58 "playlist.ecpp"
    callComp(tnt::Subcompident(std::string(), "playlist", "m3u"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[0]; // \n
  // <%include> page_exit.eh
  reply.out() << data[1]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << data[2]; // \n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::m3u_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("playlist::m3u " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
string videourl = tnt::stringTo<string>("videourl", "string", qparam.param("videourl"), reply.out().getloc());
  // </%args>

#line 19 "playlist.ecpp"
  typedef cChannel* Channel_type;
  TNT_REQUEST_PAGE_VAR(Channel_type, Channel, "cChannel* Channel", ());   // <%request> cChannel* Channel
#line 16 "playlist.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
#line 65 "playlist.ecpp"
  reply.sout() << ( videourl );
  reply.out() << data[3]; // \n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
