////////////////////////////////////////////////////////////////////////
// setup.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.setup")

// <%pre>
#line 1 "setup.ecpp"


#include <setup.h>
#include <tools.h>
#include <users.h>
#include <live.h>

using namespace vdrlive;
using namespace std;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("setup");

static const char* rawData = "D\001\000\000h\001\000\000s\001\000\000v\001\000\000'\005\000\000*\005\000\000\241\005"
  "\000\000\345\005\000\000\242\006\000\000\007\007\000\000t\007\000\000S\010\000\000\223\010\000\000\023\t\000\000W\t"
  "\000\000\353\t\000\000T\n\000\000\234\n\000\000<\013\000\000\253\013\000\000\007\014\000\000t\014\000\000S\015\000"
  "\000\261\015\000\000=\016\000\000\264\016\000\000\235\017\000\000\007\020\000\000\134\020\000\000\306\020\000\000\033"
  "\021\000\000\205\021\000\000\332\021\000\000D\022\000\000\231\022\000\000\364\022\000\000I\023\000\000\270\023\000"
  "\000\342\023\000\000\014\024\000\0005\024\000\000_\024\000\000U\025\000\000#\026\000\000\314\026\000\000;\027\000\000"
  "\227\027\000\000\354\027\000\000T\030\000\000\243\030\000\000\272\030\000\000\015\031\000\000d\031\000\000\203\031"
  "\000\000\326\031\000\0000\032\000\000\245\032\000\0000\033\000\000\215\033\000\000\015\034\000\000\016\034\000\000;"
  "\034\000\000<\034\000\000f\034\000\000g\034\000\000\226\034\000\000\227\034\000\000\303\034\000\000\304\034\000\000"
  "\354\034\000\000\355\034\000\000Y\035\000\000\253\035\000\000\301\035\000\000\303\035\000\000\304\035\000\000\316\035"
  "\000\000\226\036\000\000\370\036\000\000\371\036\000\000\372\036\000\000\n<html>\n\t<head>\n\t\t<title>VDR-Live - </t"
  "itle>\n\t\t\n\t\t\n\t\t<script type=\"text/javascript\"><!--\n\t\tfunction initform()\n\t\t{\n\t\t\tchangeduseauth(do"
  "cument.getElementById(\"useauth\"));\n\t\t\tchangeduseajax(document.getElementById(\"useAjax\"));\n\t\t\tchangedusest"
  "reamdev(document.getElementById(\"useStreamdev\"));\n\t\t\tif (document.getElementById(\"message\").value != \"\")\n"
  "\t\t\t\talert(document.getElementById(\"message\").value);\n\t\t}\n\t\tfunction changeduseauth(selection)\n\t\t{\n\t"
  "\t\tdocument.getElementById(\"authsection\").style.display = (selection.checked \? \"block\" : \"none\");\n\t\t}\n\t"
  "\tfunction setauthchanged(selection)\n\t\t{\n\t\t\tdocument.getElementById(\"authchanged\").value = 1;\n\t\t}\n\t\tfu"
  "nction changeduseajax(selection)\n\t\t{\n\t\t\tdocument.getElementById(\"ajaxsection\").style.display = (selection.ch"
  "ecked \? \"block\" : \"none\");\n\t\t}\n\t\tfunction changedusestreamdev(selection)\n\t\t{\n\t\t\tdocument.getElement"
  "ById(\"streamdevsection\").style.display = (selection.checked \? \"block\" : \"none\");\n\t\t}\n\t\t//--></script>\n"
  "\t</head>\n\t<body onload=\"initform()\">\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t\t<form method=\"post\" action"
  "=\"setup.html\">\n\t\t\t\t<input type=\"hidden\" name=\"authchanged\" value=\"\" id=\"authchanged\"/>\n\t\t\t\t<input"
  " type=\"hidden\" name=\"message\" value=\"\" id=\"message\"/>\n\t\t\t\t<table class=\"formular\" cellpadding=\"0\" ce"
  "llspacing=\"0\">\n\t\t\t\t\t<tr class=\"head\">\n\t\t\t\t\t\t<td  class=\"toprow leftcol rightcol\" colspan=\"2\"><di"
  "v class=\"boxheader\"><div><div></div></div></div></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"lab"
  "el leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n\t\t\t\t\t\t\t<input type="
  "\"checkbox\" name=\"useauth\" id=\"useauth\" value=\"1\" onclick=\"changeduseauth(this)\"/>\n\t\t\t\t\t\t\t<div id=\""
  "authsection\" style=\"display: none\">\n\t\t\t\t\t\t\t<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class="
  "\"dependent\">\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><div class=\"withmargin\">:</div></td>\n\t\t"
  "\t\t\t\t\t\t<td><input type=\"text\" name=\"login\" value=\"\" id=\"login\" onchange=\"setauthchanged(this)\" /></td>"
  "\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><div class=\"withmargin\">:</div></td>"
  "\n\t\t\t\t\t\t\t\t<td><input  type=\"password\" name=\"pass\" value=\"\" id=\"pass\" onchange=\"setauthchanged(this)"
  "\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><div class=\"withmargin\"><a"
  " href=\"users.html\"></a></div></td>\n\t\t\t\t\t\t\t\t<td/>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t"
  "\t<td class=\"label\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><input  type=\"text\" name=\"localn"
  "etmask\" value=\"\" id=\"localnetmask\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t</table>\n\t\t\t\t\t\t\t</div>\n"
  "\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\""
  ">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n\t\t\t\t\t\t\t<input type=\"checkbox\" name=\"showLogo\" id=\"sho"
  "wLogo\" value=\"1\" />\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><"
  "div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n\t\t\t\t\t\t\t<input type=\"checkbox\" na"
  "me=\"useAjax\" id=\"useAjax\" value=\"1\" onclick=\"changeduseajax(this)\"/>\n\t\t\t\t\t\t\t<div id=\"ajaxsection\" s"
  "tyle=\"display: none\">\n\t\t\t\t\t\t\t<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"dependent\">\n"
  "\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><"
  "input type=\"checkbox\" name=\"showInfoBox\" id=\"showInfoBox\" value=\"1\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t"
  "\t\t</table>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label"
  " leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n\t\t\t\t\t\t\t<input type=\"c"
  "heckbox\" name=\"useStreamdev\" id=\"useStreamdev\" value=\"1\" onclick=\"changedusestreamdev(this)\"/>\n\t\t\t\t\t\t"
  "\t<div id=\"streamdevsection\" style=\"display: none\">\n\t\t\t\t\t\t\t<table border=\"0\" cellpadding=\"0\" cellspac"
  "ing=\"0\" class=\"dependent\">\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><div class=\"withmargin\">:</"
  "div></td>\n\t\t\t\t\t\t\t\t<td><input type=\"text\" name=\"streamVideoOpt0\" id=\"streamVideoOpt0\" size=\"100\" valu"
  "e=\"\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><div class=\"withmargin"
  "\">:</div></td>\n\t\t\t\t\t\t\t\t<td><input type=\"text\" name=\"streamVideoOpt1\" id=\"streamVideoOpt1\" size=\"100"
  "\" value=\"\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><div class=\"with"
  "margin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><input type=\"text\" name=\"streamVideoOpt2\" id=\"streamVideoOpt2\" size="
  "\"100\" value=\"\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><div class="
  "\"withmargin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><input type=\"text\" name=\"streamVideoOpt3\" id=\"streamVideoOpt3\""
  " size=\"100\" value=\"\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><div c"
  "lass=\"withmargin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><input type=\"text\" name=\"streamdevport\" id=\"streamdevport"
  "\" value=\"\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><div class=\"with"
  "margin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><select name=\"streamdevtype\" size=\"1\" id=\"streamdevtype\">\n\t\t\t\t"
  "\t\t\t\t\t<option value=\"TS\" >TS</option>\n\t\t\t\t\t\t\t\t\t<option value=\"PES\" >PES</option>\n\t\t\t\t\t\t\t\t"
  "\t<option value=\"PS\" >PS</option>\n\t\t\t\t\t\t\t\t\t<option value=\"ES\" >ES</option>\n\t\t\t\t\t\t\t\t\t<option v"
  "alue=\"EXT\" >EXT</option>\n\t\t\t\t\t\t\t\t</select></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t</table>\n\t\t\t\t\t\t"
  "\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n                                        <tr>\n                         "
  "                       <td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n                          "
  "                      <td class=\"rightcol\">\n                                                        <input type=\""
  "checkbox\" name=\"markNewRec\" id=\"markNewRec\" value=\"1\" />\n                                                </td"
  ">\n                                        </tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class="
  "\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n\t\t\t\t\t\t\t<input type=\"checkbox\" name=\"showI"
  "MDb\" id=\"showIMDb\" value=\"1\" />\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"lab"
  "el leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><input type=\"text\" name=\"l"
  "astchannel\" value=\"\" id=\"lastchannel\" /></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label le"
  "ftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><input type=\"text\" name=\"times"
  "\" value=\"\" id=\"times\" />\n\t\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label le"
  "ftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><input type=\"text\" name=\"channe"
  "lGroups\" value=\"\" id=\"channelGroups\" />\n\t\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td c"
  "lass=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><input type=\"text"
  "\" name=\"scheduleDuration\" value=\"\" id=\"scheduleDuration\" />\n\t\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<"
  "tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol"
  "\">\n\t\t\t\t\t\t\t<input type=\"checkbox\" name=\"showChannelsWithoutEPG\" id=\"showChannelsWithoutEPG\" value=\"1\""
  " />\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withm"
  "argin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><select name=\"startscreen\" size=\"1\" id=\"startscreen\">"
  "\n\t\t\t\t\t\t\t<option value=\"whatsonnow\" ></option>\n\t\t\t\t\t\t\t<option value=\"whatsonnext\" ></option>\n\t\t"
  "\t\t\t\t\t<option value=\"schedule\" ></option>\n\t\t\t\t\t\t\t<option value=\"multischedule\" ></option>\n\t\t\t\t\t"
  "\t\t<option value=\"recordings\" ></option>\n\t\t\t\t\t\t\t<option value=\"timers\" ></option>\n\t\t\t\t\t\t</select>"
  "</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td"
  ">\n\t\t\t\t\t\t<td class=\"rightcol\"><select name=\"theme\" size=\"1\" id=\"theme\">\n\t\t\t\t\t\t\t<option value=\""
  "\" ></option>\n\t\t\t\t\t\t</select></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"buttonpanel leftc"
  "ol rightcol bottomrow\" colspan=\"2\">\n\t\t\t\t\t\t\t<div class=\"withmargin\">\n\t\t\t\t\t\t\t<button class=\"green"
  "\" type=\"submit\" name=\"save\" ></button>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t</tabl"
  "e>\n\t\t\t</form>\n\t\t</div>\n\t</body>\n</html>\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("setup " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
string lastchannel = tnt::stringTo<string>("lastchannel", "string", qparam.param("lastchannel"), reply.out().getloc());
bool useauth = qparam.has("useauth") ? tnt::stringToWithDefault<bool>(qparam.param("useauth"), ( false), reply.out().getloc()) : ( false);
string login = tnt::stringTo<string>("login", "string", qparam.param("login"), reply.out().getloc());
string pass = tnt::stringTo<string>("pass", "string", qparam.param("pass"), reply.out().getloc());
string times = tnt::stringTo<string>("times", "string", qparam.param("times"), reply.out().getloc());
string channelGroups = tnt::stringTo<string>("channelGroups", "string", qparam.param("channelGroups"), reply.out().getloc());
string scheduleDuration = tnt::stringTo<string>("scheduleDuration", "string", qparam.param("scheduleDuration"), reply.out().getloc());
string startscreen = tnt::stringTo<string>("startscreen", "string", qparam.param("startscreen"), reply.out().getloc());
string theme = tnt::stringTo<string>("theme", "string", qparam.param("theme"), reply.out().getloc());
string localnetmask = tnt::stringTo<string>("localnetmask", "string", qparam.param("localnetmask"), reply.out().getloc());
string showLogo = tnt::stringTo<string>("showLogo", "string", qparam.param("showLogo"), reply.out().getloc());
string useAjax = tnt::stringTo<string>("useAjax", "string", qparam.param("useAjax"), reply.out().getloc());
string showInfoBox = tnt::stringTo<string>("showInfoBox", "string", qparam.param("showInfoBox"), reply.out().getloc());
string useStreamdev = tnt::stringTo<string>("useStreamdev", "string", qparam.param("useStreamdev"), reply.out().getloc());
string markNewRec = tnt::stringTo<string>("markNewRec", "string", qparam.param("markNewRec"), reply.out().getloc());
string showIMDb = tnt::stringTo<string>("showIMDb", "string", qparam.param("showIMDb"), reply.out().getloc());
string showChannelsWithoutEPG = tnt::stringTo<string>("showChannelsWithoutEPG", "string", qparam.param("showChannelsWithoutEPG"), reply.out().getloc());
string streamdevport = tnt::stringTo<string>("streamdevport", "string", qparam.param("streamdevport"), reply.out().getloc());
string streamdevtype = tnt::stringTo<string>("streamdevtype", "string", qparam.param("streamdevtype"), reply.out().getloc());
string streamVideoOpt0 = tnt::stringTo<string>("streamVideoOpt0", "string", qparam.param("streamVideoOpt0"), reply.out().getloc());
string streamVideoOpt1 = tnt::stringTo<string>("streamVideoOpt1", "string", qparam.param("streamVideoOpt1"), reply.out().getloc());
string streamVideoOpt2 = tnt::stringTo<string>("streamVideoOpt2", "string", qparam.param("streamVideoOpt2"), reply.out().getloc());
string streamVideoOpt3 = tnt::stringTo<string>("streamVideoOpt3", "string", qparam.param("streamVideoOpt3"), reply.out().getloc());
int authchanged = qparam.has("authchanged") ? tnt::stringToWithDefault<int>(qparam.param("authchanged"), ( 0), reply.out().getloc()) : ( 0);
  // </%args>

#line 39 "setup.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 42 "setup.ecpp"

if (!logged_in && LiveSetup().UseAuth() ) return reply.redirect("login.html");
if (!cUser::CurrentUserHasRightTo(UR_EDITSETUP))
		throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );

#define SELECTIF(x) reply.out() << ( (x) ? "selected=\"selected\"" : "" );
#define CHECKIF(x) reply.out() << ( (x) ? "checked=\"checked\"" : "" );

	std::string message;

	if ( request.getMethod() == "POST") {
		if (authchanged && useauth && (login.empty() || pass.empty()))
			message = tr("Please set login and password!");
		else
		{
			LiveSetup().SetLastChannel(lastchannel != "" ? lexical_cast< int >(lastchannel):0);
			LiveSetup().SetUseAuth(useauth);
			if (useauth) {
				LiveSetup().SetAdminLogin(login);
				if (pass != "")
					LiveSetup().SetAdminPassword(pass);
				LiveSetup().SetLocalNetMask(localnetmask);
				LiveSetup().CheckLocalNet(request.getPeerIp());
			}
			LiveSetup().SetTimes(times);
			LiveSetup().SetChannelGroups(channelGroups);
			LiveSetup().SetScheduleDuration(scheduleDuration);
			LiveSetup().SetStartScreen(startscreen);
			LiveSetup().SetTheme(theme);
			LiveSetup().SetShowLogo(!showLogo.empty());
			LiveSetup().SetUseAjax(!useAjax.empty());
			if (LiveSetup().GetUseAjax()) {
				LiveSetup().SetShowInfoBox(!showInfoBox.empty());
			}
			LiveSetup().SetUseStreamdev(!useStreamdev.empty());
			LiveSetup().SetStreamdevPort(streamdevport.empty() ? 3000 : lexical_cast<int>(streamdevport));
			LiveSetup().SetStreamdevType(streamdevtype.empty() ? "PES" : streamdevtype);
			LiveSetup().SetMarkNewRec(!markNewRec.empty());

			std::string def = "ffmpeg -loglevel warning -f mpegts -analyzeduration 1.2M -probesize 5M "
				"-i <input> -map 0:v -map 0:a:0 -c:v copy -c:a aac -ac 2";
			LiveSetup().SetStreamVideoOpt0(streamVideoOpt0.empty() ? def : streamVideoOpt0);
			LiveSetup().SetStreamVideoOpt1(streamVideoOpt1.empty() ? def : streamVideoOpt1);
			LiveSetup().SetStreamVideoOpt2(streamVideoOpt2.empty() ? def : streamVideoOpt2);
			LiveSetup().SetStreamVideoOpt3(streamVideoOpt3.empty() ? def : streamVideoOpt3);

			LiveSetup().SetShowIMDb(!showIMDb.empty());
			LiveSetup().SetShowChannelsWithoutEPG(!showChannelsWithoutEPG.empty());
			LiveSetup().SaveSetup();

			message = tr("Setup saved.");
		}
	}
	pageTitle = tr("Setup");
	int ilastchannel = LiveSetup().GetLastChannel();
	if (ilastchannel == std::numeric_limits< int >::max())
		lastchannel = "";
	else
		lastchannel = lexical_cast<std::string, int>(ilastchannel);

	login = LiveSetup().GetAdminLogin();
	useauth = LiveSetup().GetUseAuth();
	times = LiveSetup().GetTimes();
	channelGroups = LiveSetup().GetChannelGroups();
	scheduleDuration = LiveSetup().GetScheduleDuration();
	startscreen = LiveSetup().GetStartScreen();
	theme = LiveSetup().GetTheme();
	localnetmask = LiveSetup().GetLocalNetMask();
	showLogo = LiveSetup().GetShowLogo() ? "1" : "";
	useAjax = LiveSetup().GetUseAjax() ? "1" : "";
	showInfoBox = LiveSetup().GetShowInfoBox() ? "1" : "";
	useStreamdev = LiveSetup().GetUseStreamdev() ? "1" : "";
	streamdevport = lexical_cast<std::string, int>(LiveSetup().GetStreamdevPort());
	streamdevtype = LiveSetup().GetStreamdevType();
	markNewRec = LiveSetup().GetMarkNewRec() ? "1" : "";
	streamVideoOpt0 = LiveSetup().GetStreamVideoOpt0();
	streamVideoOpt1 = LiveSetup().GetStreamVideoOpt1();
	streamVideoOpt2 = LiveSetup().GetStreamVideoOpt2();
	streamVideoOpt3 = LiveSetup().GetStreamVideoOpt3();
	showIMDb = LiveSetup().GetShowIMDb() ? "1" : "";
	showChannelsWithoutEPG = LiveSetup().GetShowChannelsWithoutEPG() ? "1" : "";

  // <& pageelems.doc_type ...
  { 
#line 124 "setup.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 124 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[0]; // \n<html>\n\t<head>\n\t\t<title>VDR-Live - 
#line 127 "setup.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << data[1]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 128 "setup.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 128 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << data[2]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 129 "setup.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 129 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << data[3]; // \n\t\t<script type="text/javascript"><!--\n\t\tfunction initform()\n\t\t{\n\t\t\tchangeduseauth(document.getElementById("useauth"));\n\t\t\tchangeduseajax(document.getElementById("useAjax"));\n\t\t\tchangedusestreamdev(document.getElementById("useStreamdev"));\n\t\t\tif (document.getElementById("message").value != "")\n\t\t\t\talert(document.getElementById("message").value);\n\t\t}\n\t\tfunction changeduseauth(selection)\n\t\t{\n\t\t\tdocument.getElementById("authsection").style.display = (selection.checked \? "block" : "none");\n\t\t}\n\t\tfunction setauthchanged(selection)\n\t\t{\n\t\t\tdocument.getElementById("authchanged").value = 1;\n\t\t}\n\t\tfunction changeduseajax(selection)\n\t\t{\n\t\t\tdocument.getElementById("ajaxsection").style.display = (selection.checked \? "block" : "none");\n\t\t}\n\t\tfunction changedusestreamdev(selection)\n\t\t{\n\t\t\tdocument.getElementById("streamdevsection").style.display = (selection.checked \? "block" : "none");\n\t\t}\n\t\t//--></script>\n\t</head>\n\t<body onload="initform()">\n\t\t
  // <& pageelems.logo ...
  { 
#line 158 "setup.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 158 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << data[4]; // \n\t\t
  // <& menu ...
  { 
#line 159 "setup.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 159 "setup.ecpp"
    _tnt_cq4.add( "active", tnt::toString(("setup"), reply.out().getloc() ) );
#line 159 "setup.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << data[5]; // \n\t\t<div class="inhalt">\n\t\t\t<form method="post" action="setup.html">\n\t\t\t\t<input type="hidden" name="authchanged" value="
#line 162 "setup.ecpp"
  reply.sout() << ( authchanged );
  reply.out() << data[6]; // " id="authchanged"/>\n\t\t\t\t<input type="hidden" name="message" value="
#line 163 "setup.ecpp"
  reply.sout() << ( message );
  reply.out() << data[7]; // " id="message"/>\n\t\t\t\t<table class="formular" cellpadding="0" cellspacing="0">\n\t\t\t\t\t<tr class="head">\n\t\t\t\t\t\t<td  class="toprow leftcol rightcol" colspan="2"><div class="boxheader"><div><div>
#line 166 "setup.ecpp"
  reply.sout() << ( tr("Setup") );
  reply.out() << data[8]; // </div></div></div></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 169 "setup.ecpp"
  reply.sout() << ( tr("Use authentication") );
  reply.out() << data[9]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="useauth" id="useauth" value="1" 
#line 171 "setup.ecpp"
 CHECKIF(useauth); 
  reply.out() << data[10]; // onclick="changeduseauth(this)"/>\n\t\t\t\t\t\t\t<div id="authsection" style="display: none">\n\t\t\t\t\t\t\t<table border="0" cellpadding="0" cellspacing="0" class="dependent">\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 175 "setup.ecpp"
  reply.sout() << ( tr("Admin login") );
  reply.out() << data[11]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input type="text" name="login" value="
#line 176 "setup.ecpp"
  reply.sout() << ( login );
  reply.out() << data[12]; // " id="login" onchange="setauthchanged(this)" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 179 "setup.ecpp"
  reply.sout() << ( tr("Admin password") );
  reply.out() << data[13]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input  type="password" name="pass" value="
#line 180 "setup.ecpp"
  reply.sout() << ( pass );
  reply.out() << data[14]; // " id="pass" onchange="setauthchanged(this)" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin"><a href="users.html">
#line 183 "setup.ecpp"
  reply.sout() << ( tr("User management") );
  reply.out() << data[15]; // </a></div></td>\n\t\t\t\t\t\t\t\t<td/>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 187 "setup.ecpp"
  reply.sout() << ( tr("Local net (no login required)") );
  reply.out() << data[16]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input  type="text" name="localnetmask" value="
#line 188 "setup.ecpp"
  reply.sout() << ( localnetmask );
  reply.out() << data[17]; // " id="localnetmask" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t</table>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 195 "setup.ecpp"
  reply.sout() << ( tr("Show live logo image") );
  reply.out() << data[18]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="showLogo" id="showLogo" value="1" 
#line 197 "setup.ecpp"
 CHECKIF(!showLogo.empty()); 
  reply.out() << data[19]; // />\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 201 "setup.ecpp"
  reply.sout() << ( tr("Use ajax technology") );
  reply.out() << data[20]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="useAjax" id="useAjax" value="1" 
#line 203 "setup.ecpp"
 CHECKIF(!useAjax.empty()); 
  reply.out() << data[21]; // onclick="changeduseajax(this)"/>\n\t\t\t\t\t\t\t<div id="ajaxsection" style="display: none">\n\t\t\t\t\t\t\t<table border="0" cellpadding="0" cellspacing="0" class="dependent">\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 207 "setup.ecpp"
  reply.sout() << ( tr("Show dynamic VDR information box") );
  reply.out() << data[22]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input type="checkbox" name="showInfoBox" id="showInfoBox" value="1" 
#line 208 "setup.ecpp"
 CHECKIF(!showInfoBox.empty()); 
  reply.out() << data[23]; // /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t</table>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 215 "setup.ecpp"
  reply.sout() << ( tr("Allow video streaming") );
  reply.out() << data[24]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="useStreamdev" id="useStreamdev" value="1" 
#line 217 "setup.ecpp"
 CHECKIF(!useStreamdev.empty()); 
  reply.out() << data[25]; // onclick="changedusestreamdev(this)"/>\n\t\t\t\t\t\t\t<div id="streamdevsection" style="display: none">\n\t\t\t\t\t\t\t<table border="0" cellpadding="0" cellspacing="0" class="dependent">\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 221 "setup.ecpp"
  reply.sout() << ( tr("Web-Streaming h264") );
  reply.out() << data[26]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input type="text" name="streamVideoOpt0" id="streamVideoOpt0" size="100" value="
#line 222 "setup.ecpp"
  reply.sout() << ( streamVideoOpt0 );
  reply.out() << data[27]; // " /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 225 "setup.ecpp"
  reply.sout() << ( tr("Web-Streaming HEVC") );
  reply.out() << data[28]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input type="text" name="streamVideoOpt1" id="streamVideoOpt1" size="100" value="
#line 226 "setup.ecpp"
  reply.sout() << ( streamVideoOpt1 );
  reply.out() << data[29]; // " /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 229 "setup.ecpp"
  reply.sout() << ( tr("Web-Streaming MPEG2") );
  reply.out() << data[30]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input type="text" name="streamVideoOpt2" id="streamVideoOpt2" size="100" value="
#line 230 "setup.ecpp"
  reply.sout() << ( streamVideoOpt2 );
  reply.out() << data[31]; // " /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 233 "setup.ecpp"
  reply.sout() << ( tr("Web-Streaming others") );
  reply.out() << data[32]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input type="text" name="streamVideoOpt3" id="streamVideoOpt3" size="100" value="
#line 234 "setup.ecpp"
  reply.sout() << ( streamVideoOpt3 );
  reply.out() << data[33]; // " /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 237 "setup.ecpp"
  reply.sout() << ( tr("Streamdev server port") );
  reply.out() << data[34]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input type="text" name="streamdevport" id="streamdevport" value="
#line 238 "setup.ecpp"
  reply.sout() << ( streamdevport );
  reply.out() << data[35]; // " /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 241 "setup.ecpp"
  reply.sout() << ( tr("Streamdev stream type") );
  reply.out() << data[36]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><select name="streamdevtype" size="1" id="streamdevtype">\n\t\t\t\t\t\t\t\t\t<option value="TS" 
#line 243 "setup.ecpp"
 SELECTIF(streamdevtype == "TS") 
  reply.out() << data[37]; // >TS</option>\n\t\t\t\t\t\t\t\t\t<option value="PES" 
#line 244 "setup.ecpp"
 SELECTIF(streamdevtype == "PES") 
  reply.out() << data[38]; // >PES</option>\n\t\t\t\t\t\t\t\t\t<option value="PS" 
#line 245 "setup.ecpp"
 SELECTIF(streamdevtype == "PS") 
  reply.out() << data[39]; // >PS</option>\n\t\t\t\t\t\t\t\t\t<option value="ES" 
#line 246 "setup.ecpp"
 SELECTIF(streamdevtype == "ES") 
  reply.out() << data[40]; // >ES</option>\n\t\t\t\t\t\t\t\t\t<option value="EXT" 
#line 247 "setup.ecpp"
 SELECTIF(streamdevtype == "EXT") 
  reply.out() << data[41]; // >EXT</option>\n\t\t\t\t\t\t\t\t</select></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t</table>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n                                        <tr>\n                                                <td class="label leftcol"><div class="withmargin">
#line 255 "setup.ecpp"
  reply.sout() << ( tr("mark new recordings") );
  reply.out() << data[42]; // :</div></td>\n                                                <td class="rightcol">\n                                                        <input type="checkbox" name="markNewRec" id="markNewRec" value="1" 
#line 257 "setup.ecpp"
 CHECKIF(!markNewRec.empty()); 
  reply.out() << data[43]; // />\n                                                </td>\n                                        </tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 261 "setup.ecpp"
  reply.sout() << ( tr("Add links to IMDb") );
  reply.out() << data[44]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="showIMDb" id="showIMDb" value="1" 
#line 263 "setup.ecpp"
 CHECKIF(!showIMDb.empty()); 
  reply.out() << data[45]; // />\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 267 "setup.ecpp"
  reply.sout() << ( tr("Last channel to display") );
  reply.out() << data[46]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="text" name="lastchannel" value="
#line 268 "setup.ecpp"
  reply.sout() << ( lastchannel );
  reply.out() << data[47]; // " id="lastchannel" /></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 271 "setup.ecpp"
  reply.sout() << ( tr("Additional fixed times in 'What's on?'") );
  reply.out() << data[48]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="text" name="times" value="
#line 272 "setup.ecpp"
  reply.sout() << ( times );
  reply.out() << data[49]; // " id="times" />\n\t\t\t\t\t\t\t
  // <& tooltip.help ...
  { 
#line 273 "setup.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 273 "setup.ecpp"
    _tnt_cq5.add( "text", tnt::toString((tr("Format is HH:MM. Separate multiple times with a semicolon")), reply.out().getloc() ) );
#line 273 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << data[50]; // </td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 276 "setup.ecpp"
  reply.sout() << ( tr("Channel groups for MultiSchedule") );
  reply.out() << data[51]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="text" name="channelGroups" value="
#line 277 "setup.ecpp"
  reply.sout() << ( channelGroups );
  reply.out() << data[52]; // " id="channelGroups" />\n\t\t\t\t\t\t\t
  // <& tooltip.help ...
  { 
#line 278 "setup.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 278 "setup.ecpp"
    _tnt_cq6.add( "text", tnt::toString((tr("Separate channels with a comma ',', separate groups with a semi-colon ';'")), reply.out().getloc() ) );
#line 278 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << data[53]; // </td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 281 "setup.ecpp"
  reply.sout() << ( tr("Duration of MultiSchedule in hours") );
  reply.out() << data[54]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="text" name="scheduleDuration" value="
#line 282 "setup.ecpp"
  reply.sout() << ( scheduleDuration );
  reply.out() << data[55]; // " id="scheduleDuration" />\n\t\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 286 "setup.ecpp"
  reply.sout() << ( tr("Show channels without EPG") );
  reply.out() << data[56]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="showChannelsWithoutEPG" id="showChannelsWithoutEPG" value="1" 
#line 288 "setup.ecpp"
 CHECKIF(!showChannelsWithoutEPG.empty()); 
  reply.out() << data[57]; // />\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 293 "setup.ecpp"
  reply.sout() << ( tr("Start page") );
  reply.out() << data[58]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><select name="startscreen" size="1" id="startscreen">\n\t\t\t\t\t\t\t<option value="whatsonnow" 
#line 295 "setup.ecpp"
 SELECTIF(startscreen == "whatsonnow") 
  reply.out() << data[59]; // >
#line 295 "setup.ecpp"
  reply.sout() << ( trVDR("What's on now?") );
  reply.out() << data[60]; // </option>\n\t\t\t\t\t\t\t<option value="whatsonnext" 
#line 296 "setup.ecpp"
 SELECTIF(startscreen == "whatsonnext") 
  reply.out() << data[61]; // >
#line 296 "setup.ecpp"
  reply.sout() << ( trVDR("What's on next?") );
  reply.out() << data[62]; // </option>\n\t\t\t\t\t\t\t<option value="schedule" 
#line 297 "setup.ecpp"
 SELECTIF(startscreen == "schedule") 
  reply.out() << data[63]; // >
#line 297 "setup.ecpp"
  reply.sout() << ( trVDR("Schedule") );
  reply.out() << data[64]; // </option>\n\t\t\t\t\t\t\t<option value="multischedule" 
#line 298 "setup.ecpp"
 SELECTIF(startscreen == "multischedule") 
  reply.out() << data[65]; // >
#line 298 "setup.ecpp"
  reply.sout() << ( tr("MultiSchedule") );
  reply.out() << data[66]; // </option>\n\t\t\t\t\t\t\t<option value="recordings" 
#line 299 "setup.ecpp"
 SELECTIF(startscreen == "recordings") 
  reply.out() << data[67]; // >
#line 299 "setup.ecpp"
  reply.sout() << ( trVDR("Recordings") );
  reply.out() << data[68]; // </option>\n\t\t\t\t\t\t\t<option value="timers" 
#line 300 "setup.ecpp"
 SELECTIF(startscreen == "timers") 
  reply.out() << data[69]; // >
#line 300 "setup.ecpp"
  reply.sout() << ( trVDR("Timers") );
  reply.out() << data[70]; // </option>\n\t\t\t\t\t\t</select></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 304 "setup.ecpp"
  reply.sout() << ( tr("Theme") );
  reply.out() << data[71]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><select name="theme" size="1" id="theme">\n
#line 306 "setup.ecpp"

{
	const string dirPath(Plugin::GetResourceDirectory() + "/themes");
	cReadDir d(dirPath.c_str());
	struct dirent* e;
	string parent("..");
	string current(".");
	string cvsDir("CVS");
	while ((e = d.Next())) {
		if ((current == e->d_name) || (parent == e->d_name) || (cvsDir == e->d_name)) {
			continue;
		}
		/* Check if entry is a directory: I do not rely on e->d_type
		   here because on some systems it is allways DT_UNKNOWN. Also
		   testing for DT_DIR does not take into account symbolic
		   links to directories.
		*/
		struct stat buf;
		if ((stat((dirPath + "/" + e->d_name).c_str(), &buf) != 0) || (!S_ISDIR(buf.st_mode))) {
			continue;
		}

  reply.out() << data[72]; // \t\t\t\t\t\t\t<option value="
#line 328 "setup.ecpp"
  reply.sout() << ( e->d_name );
  reply.out() << data[73]; // " 
#line 328 "setup.ecpp"
 SELECTIF(theme == e->d_name) 
  reply.out() << data[74]; // >
#line 328 "setup.ecpp"
  reply.sout() << ( e->d_name );
  reply.out() << data[75]; // </option>\n
#line 329 "setup.ecpp"

	}
}

  reply.out() << data[76]; // \t\t\t\t\t\t</select></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="buttonpanel leftcol rightcol bottomrow" colspan="2">\n\t\t\t\t\t\t\t<div class="withmargin">\n\t\t\t\t\t\t\t<button class="green" type="submit" name="save" >
#line 338 "setup.ecpp"
  reply.sout() << ( tr("Save") );
  reply.out() << data[77]; // </button>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t</table>\n\t\t\t</form>\n\t\t</div>\n\t</body>\n</html>\n\n
  // <%include> page_exit.eh
  reply.out() << data[78]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << data[79]; // \n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
