////////////////////////////////////////////////////////////////////////
// stream.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.stream")

// <%pre>
#line 1 "stream.ecpp"


#include <livefeatures.h>
#include <setup.h>
#include <ffmpeg.h>
#include <tools.h>
#include <epg_events.h>

using namespace std;
using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class channel_selection_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        channel_selection_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    channel_selection_type channel_selection;
};

static tnt::ComponentFactoryImpl<_component_> Factory("stream");

static const char* rawData = "\214\000\000\000\300\000\000\000\313\000\000\000\316\000\000\000-\001\000\0000\001\000"
  "\000C\002\000\000K\002\000\000\244\003\000\000\355\003\000\000X\004\000\000\201\004\000\000\006\005\000\000\023\005"
  "\000\000\032\005\000\000\033\005\000\0007\005\000\000X\005\000\000d\005\000\000\177\005\000\000\207\005\000\000\"\006"
  "\000\000$\006\000\000%\006\000\000Q\006\000\000k\006\000\000l\006\000\000m\006\000\000\306\006\000\000\340\006\000"
  "\000\364\006\000\000\371\006\000\000D\007\000\000\212\007\000\000\230\007\000\000\n<!DOCTYPE html>\n<html>\n\t<head>"
  "\n\t\t<title>VDR Live - </title>\n\t\t\n\t\t\n\t\t<script> window.onbeforeunload = function() { player.stop(); } </sc"
  "ript>\n\t</head>\n\t<body>\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n            <center>\n\t\t\t<div id=\"player\">\n"
  "\n\t\t\t\t<script src=\"https://cdn.jsdelivr.net/npm/clappr@latest/dist/clappr.min.js\"></script>\n\t\t\t\t<script>\n"
  "\t\t\t\tClappr.Log.setLevel(Clappr.Log.LEVEL_INFO);\n\t\t\t\tvar player = new Clappr.Player({\n\t\t\t\t\tsource: \"me"
  "dia//master_.m3u8\",\n\t\t\t\t\tparentId: \"#player\",\n\t\t\t\t\twidth: 1280, height: 720,\n\t\t\t\t\tautoPlay: \"tr"
  "ue\",\n\t\t\t\t\tevents: {\n\t\t\t\t\t\tonError: function(error) { console.log('Calppr.Player error: ', error); playe"
  "r.play(); },\n\t\t\t\t\t\tonEnded: function() { console.log('Clappr.Player ended'); player.play(); },\n\t\t\t\t\t}\n"
  "\t\t\t\t});\n\t\t\t\t</script>\n\t\t\t</div>\n            </center>\t\t\t\n\t\t\t<table class=\"listing\" cellspacing"
  "=\"0\" cellpadding=\"0\">\n\t\t\t\t<tr>\n\t\t\t\t\t\n\t\t\t\t\t<td class=\"topaligned bottomrow\">\n\t\t\t\t\t\t<div "
  "class=\"withmargin\">\n\t\t\t\t\t\t\t<div class=\"nomargin nowrap\"></div>\n\t\t\t\t\t\t\t<div class=\"progress\"><di"
  "v></div></div>\n\t\t\t\t\t\t</div>\n\t\t\t\t\t</td>\n\t\t\t\t\t<td class=\"topaligned bottomrow\" style=\"width: 788p"
  "x\">\n\t\t\t\t\t\t<div class=\"more withmargin\">\n\t\t\t\t\t\t    <a\n\t\t\t\t\t\t\t\n\t\t\t\t\t\t\t><span class=\"t"
  "itle\"></span><br /><span class=\"short\"></span></a>\n\t\t\t\t\t\t\t<span class=\"title\"></span>\n\t\t\t\t\t\t</div"
  ">\n\t\t\t\t\t</td>\n\t\t\t\t\t<td class=\"topaligned rightcol bottomrow\" style=\"width: 250px\"><div class=\"station"
  " withmargin\"><a\thref=\"schedule.html\?channel=\" ></a></div>\n\t\t\t\t\t</td>\n\t\t\t\t</tr>\n\t\t\t</table>\n\t\t<"
  "/div>\n\t</body>\n</html>\n\n\n<form action=\"stream.html\" method=\"get\" id=\"channels\">\n  <span>\n    <label for"
  "=\"channel\">:&nbsp;<span class=\"bold\"></span></label>\n    \n    \n  </span>\n</form>\n<span class=\"sep\">|</span"
  ">\n<a href=\"stream.html\?channel=\">\302\253 Prev</a>\n<span class=\"sep\">|</span>\n<a href=\"stream.html\?channel="
  "\">Next \302\273</a>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    channel_selection(*this, "channel_selection")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("stream " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
tChannelID channelid = tnt::stringTo<tChannelID>("channelid", "tChannelID", qparam.param("channelid"), reply.out().getloc());
int channel = qparam.has("channel") ? tnt::stringToWithDefault<int>(qparam.param("channel"), ( 1), reply.out().getloc()) : ( 1);
  // </%args>

#line 18 "stream.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 19 "stream.ecpp"
  typedef FFmpegThread * f_worker_type;
  TNT_SESSION_GLOBAL_VAR(f_worker_type, f_worker, "FFmpegThread * f_worker", ( NULL));   // <%session> FFmpegThread * f_worker( NULL)
#line 22 "stream.ecpp"
  typedef cChannel* Channel_type;
  TNT_REQUEST_PAGE_VAR(Channel_type, Channel, "cChannel* Channel", ());   // <%request> cChannel* Channel
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 25 "stream.ecpp"

	if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

	pageTitle = trVDR("Stream");

	// check for session cookie.
	string session;
	if (request.hasCookie("tntnet")) {
		session = request.getCookie("tntnet");
		dsyslog("vdrlive::stream::session(%s)", session.c_str());
	}
	else {
		esyslog("vdrlive::stream: no session cookie found");
		return reply.redirect("");
	}

#if VDRVERSNUM < 20301
	ReadLock channelsLock( Channels );
	if ( !channelsLock )
		throw HtmlError( tr("Couldn't aquire access to channels, please try again later.") );
#endif

	if ( qparam.has("channelid") ) {
#if VDRVERSNUM >= 20301
		LOCK_CHANNELS_READ;
		cChannel *c = (cChannel *)Channels->GetByChannelID( channelid );
#else
		cChannel *c = Channels.GetByChannelID( channelid );
#endif
		if ( c ) channel = c->Number();
	}

	if ( channel > 0 ) {
#if VDRVERSNUM >= 20301
		LOCK_CHANNELS_READ;
		Channel = (cChannel *)Channels->GetByNumber( channel );
#else
		Channel = Channels.GetByNumber( channel );
#endif
	}
	if ( Channel == 0 )
		throw HtmlError( tr("Couldn't find channel or no channels available. Maybe you mistyped your request?") );

	dsyslog("vdrlive::stream::vtype(%d)", Channel->Vtype());
	dsyslog("vdrlive::stream::f_worker(%p)", f_worker);
	if ( !f_worker) {
		f_worker = new FFmpegThread();
		dsyslog("vdrlive::stream: new FFmpegThread created");
	}

	switch( Channel->Vtype() ) {
		case 27: // h264
			f_worker->StartFFmpeg(session, channel, 0);
			break;
		case 36: // h265
			f_worker->StartFFmpeg(session, channel, 1);
			break;
		case 2: // mpeg2
			f_worker->StartFFmpeg(session, channel, 2);
			break;
		default: // others
			f_worker->StartFFmpeg(session, channel, 3);
	}
	dsyslog("vdrlive::stream::StartFFmpeg(%d)", channel);


  reply.out() << data[0]; // \n<!DOCTYPE html>\n<html>\n\t<head>\n\t\t<title>VDR Live - 
#line 95 "stream.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << data[1]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 96 "stream.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 96 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[2]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 97 "stream.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 97 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << data[3]; // \n\t\t<script> window.onbeforeunload = function() { player.stop(); } </script>\n\t</head>\n\t<body>\n\t\t
  // <& pageelems.logo ...
  { 
#line 101 "stream.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 101 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << data[4]; // \n\t\t
  // <& menu ...
  { 
#line 102 "stream.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 102 "stream.ecpp"
    _tnt_cq3.add( "active", tnt::toString(("stream"), reply.out().getloc() ) );
#line 102 "stream.ecpp"
    _tnt_cq3.add( "component", tnt::toString(("stream.channel_selection"), reply.out().getloc() ) );
#line 102 "stream.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << data[5]; // \n\t\t<div class="inhalt">\n            <center>\n\t\t\t<div id="player">\n\n\t\t\t\t<script src="https://cdn.jsdelivr.net/npm/clappr@latest/dist/clappr.min.js"></script>\n\t\t\t\t<script>\n\t\t\t\tClappr.Log.setLevel(Clappr.Log.LEVEL_INFO);\n\t\t\t\tvar player = new Clappr.Player({\n\t\t\t\t\tsource: "media/
#line 111 "stream.ecpp"
  reply.sout() << ( session );
  reply.out() << data[6]; // /master_
#line 111 "stream.ecpp"
  reply.sout() << ( std::to_string(channel) );
  reply.out() << data[7]; // .m3u8",\n\t\t\t\t\tparentId: "#player",\n\t\t\t\t\twidth: 1280, height: 720,\n\t\t\t\t\tautoPlay: "true",\n\t\t\t\t\tevents: {\n\t\t\t\t\t\tonError: function(error) { console.log('Calppr.Player error: ', error); player.play(); },\n\t\t\t\t\t\tonEnded: function() { console.log('Clappr.Player ended'); player.play(); },\n\t\t\t\t\t}\n\t\t\t\t});\n\t\t\t\t</script>\n\t\t\t</div>\n            </center>\t\t\t\n
#line 123 "stream.ecpp"

dsyslog("vdrlive::stream: generating EPG info");
const cSchedule *Schedule = NULL;
{
#if VDRVERSNUM >= 20301

	LOCK_SCHEDULES_READ;
#else
	cSchedulesLock schedulesLock;
	const cSchedules* Schedules = cSchedules::Schedules(schedulesLock);
#endif

	Schedule = Schedules->GetSchedule(Channel);
}
const cEvent *Event = NULL;
if (Schedule)
	Event = Schedule->GetPresentEvent();

EpgInfoPtr epgEvent;
if (Event) {
	epgEvent = EpgEvents::CreateEpgInfo(Channel, Event);

	tChannelID chanId;
	tEventID eventId;
	EpgEvents::DecodeDomId(epgEvent->Id(), chanId, eventId);
	char const * timeFormat = tr("%I:%M %p");
	char const * dateFormat = tr("%A, %x");
	string headTime = FormatDateTime(timeFormat, time(0));
	string headDate = FormatDateTime(dateFormat, time(0));
	string startTime(epgEvent->StartTime(tr("%I:%M %p")));
	string endTime(epgEvent->EndTime(tr("%I:%M %p")));
	string startDate(epgEvent->StartTime(tr("%a, %x")));

	string timeSpan(startTime + " - " + endTime);

	if (startTime.empty() && endTime.empty()) {
		timeSpan = headTime;
		startDate = headDate;
	}
static const size_t maximumDescriptionLength = 300;
string longDescription = StringEscapeAndBreak(StringWordTruncate(epgEvent->LongDescr(), maximumDescriptionLength))
	+ "<br/><br/>" + tr("Click to view details.");
	
  reply.out() << data[8]; // \t\t\t<table class="listing" cellspacing="0" cellpadding="0">\n\t\t\t\t<tr>\n\t\t\t\t\t
  // <& pageelems.epg_tool_box ...
  { 
#line 168 "stream.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 168 "stream.ecpp"
    _tnt_cq4.add( "detail", tnt::toString((0), reply.out().getloc() ) );
#line 168 "stream.ecpp"
    _tnt_cq4.add( "endTime", tnt::toString((epgEvent->GetEndTime()), reply.out().getloc() ) );
#line 168 "stream.ecpp"
    _tnt_cq4.add( "epgid", tnt::toString((epgEvent->Id()), reply.out().getloc() ) );
#line 168 "stream.ecpp"
    _tnt_cq4.add( "lastCurrentChanel", tnt::toString((1), reply.out().getloc() ) );
#line 168 "stream.ecpp"
    _tnt_cq4.add( "startTime", tnt::toString((epgEvent->GetStartTime()), reply.out().getloc() ) );
#line 168 "stream.ecpp"
    _tnt_cq4.add( "title", tnt::toString((epgEvent->Title()), reply.out().getloc() ) );
#line 168 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "epg_tool_box"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << data[9]; // \n\t\t\t\t\t<td class="topaligned bottomrow">\n\t\t\t\t\t\t<div class="withmargin">\n\t\t\t\t\t\t\t<div class="nomargin nowrap">
#line 171 "stream.ecpp"
  reply.sout() << ( (timeSpan) );
  reply.out() << data[10]; // </div>\n\t\t\t\t\t\t\t<div class="progress"><div>
  // <& pageelems.progressbar ...
  { 
#line 172 "stream.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 172 "stream.ecpp"
    _tnt_cq5.add( "duration", tnt::toString((epgEvent->Duration()), reply.out().getloc() ) );
#line 172 "stream.ecpp"
    _tnt_cq5.add( "progress", tnt::toString((epgEvent->Elapsed()), reply.out().getloc() ) );
#line 172 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "progressbar"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << data[11]; // </div></div>\n\t\t\t\t\t\t</div>\n\t\t\t\t\t</td>\n\t\t\t\t\t<td class="topaligned bottomrow" style="width: 788px">\n\t\t\t\t\t\t<div class="more withmargin">\n
#line 177 "stream.ecpp"
						if (eventId != 0) {

  reply.out() << data[12]; // \t\t\t\t\t\t    <a\n
#line 179 "stream.ecpp"
							if (!longDescription.empty()) {

  reply.out() << data[13]; // \t\t\t\t\t\t\t
  // <& tooltip.hint ...
  { 
#line 180 "stream.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 180 "stream.ecpp"
    _tnt_cq6.add( "text", tnt::toString((longDescription), reply.out().getloc() ) );
#line 180 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 180 "stream.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 180 "stream.ecpp"
    _tnt_cq7.add( "domId", tnt::toString((epgEvent->Id()), reply.out().getloc() ) );
#line 180 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << data[14]; // \n
#line 181 "stream.ecpp"
							}

  reply.out() << data[15]; // \t\t\t\t\t\t\t><span class="title">
#line 182 "stream.ecpp"
  reply.sout() << ( (epgEvent->Title()) );
  reply.out() << data[16]; // </span><br /><span class="short">
#line 182 "stream.ecpp"
  reply.sout() << ( (epgEvent->ShortDescr()) );
  reply.out() << data[17]; // </span></a>\n
#line 183 "stream.ecpp"
							} else {

  reply.out() << data[18]; // \t\t\t\t\t\t\t<span class="title">
#line 184 "stream.ecpp"
  reply.sout() << ( (epgEvent->Title()) );
  reply.out() << data[19]; // </span>\n
#line 185 "stream.ecpp"
							}

  reply.out() << data[20]; // \t\t\t\t\t\t</div>\n\t\t\t\t\t</td>\n\t\t\t\t\t<td class="topaligned rightcol bottomrow" style="width: 250px"><div class="station withmargin"><a\thref="schedule.html\?channel=
#line 188 "stream.ecpp"
  reply.sout() << ( std::to_string(channel) );
  reply.out() << data[21]; // " 
  // <& tooltip.hint ...
  { 
#line 188 "stream.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 188 "stream.ecpp"
    _tnt_cq8.add( "text", tnt::toString((tr("View the schedule of this channel")), reply.out().getloc() ) );
#line 188 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << data[22]; // >
#line 188 "stream.ecpp"
  reply.sout() << ( std::to_string(channel) );
#line 188 "stream.ecpp"
  reply.sout() << ( tr(" - ") );
#line 188 "stream.ecpp"
  reply.sout() << ( (epgEvent->Caption()) );
  reply.out() << data[23]; // </a></div>\n\t\t\t\t\t</td>\n\t\t\t\t</tr>\n\t\t\t</table>\n
#line 192 "stream.ecpp"
} // if (Event)

  reply.out() << data[24]; // \t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << data[25]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << data[26]; // \n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::channel_selection_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("stream::channel_selection " << qparam.getUrl());
  tnt::DataChunks data(rawData);
#line 22 "stream.ecpp"
  typedef cChannel* Channel_type;
  TNT_REQUEST_PAGE_VAR(Channel_type, Channel, "cChannel* Channel", ());   // <%request> cChannel* Channel
#line 18 "stream.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 19 "stream.ecpp"
  typedef FFmpegThread * f_worker_type;
  TNT_SESSION_GLOBAL_VAR(f_worker_type, f_worker, "FFmpegThread * f_worker", ( NULL));   // <%session> FFmpegThread * f_worker( NULL)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  reply.out() << data[27]; // <form action="stream.html" method="get" id="channels">\n  <span>\n    <label for="channel">
#line 201 "stream.ecpp"
  reply.sout() << ( tr("Channel") );
  reply.out() << data[28]; // :&nbsp;<span class="bold">
#line 201 "stream.ecpp"
  reply.sout() << ( std::to_string(Channel->Number()) );
  reply.out() << data[29]; // </span></label>\n    
  // <& channels_widget ...
  { 
#line 202 "stream.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 202 "stream.ecpp"
    _tnt_cq9.add( "name", tnt::toString(("channel"), reply.out().getloc() ) );
#line 202 "stream.ecpp"
    _tnt_cq9.add( "onchange", tnt::toString(("player.stop(); document.forms.channels.submit()"), reply.out().getloc() ) );
#line 202 "stream.ecpp"
    _tnt_cq9.add( "selected", tnt::toString((Channel ? *Channel->GetChannelID().ToString() : ""), reply.out().getloc() ) );
#line 202 "stream.ecpp"
    callComp(tnt::Compident(std::string(), "channels_widget"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << data[30]; // \n    
  // <& pageelems.ajax_action_href ...
  { 
#line 203 "stream.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 203 "stream.ecpp"
    _tnt_cq10.add( "action", tnt::toString("switch_channel", reply.out().getloc() ) );
#line 203 "stream.ecpp"
    _tnt_cq10.add( "alt", tnt::toString("", reply.out().getloc() ) );
#line 203 "stream.ecpp"
    _tnt_cq10.add( "image", tnt::toString("zap.png", reply.out().getloc() ) );
#line 203 "stream.ecpp"
    _tnt_cq10.add( "param", tnt::toString((Channel->GetChannelID()), reply.out().getloc() ) );
#line 203 "stream.ecpp"
    _tnt_cq10.add( "tip", tnt::toString((tr("Switch to this channel.")), reply.out().getloc() ) );
#line 203 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << data[31]; // \n  </span>\n</form>\n<span class="sep">|</span>\n<a href="stream.html\?channel=
#line 207 "stream.ecpp"
  reply.sout() << ( std::max(0, ((int)Channel->Number() - 1)) );
  reply.out() << data[32]; // ">\302\253 Prev</a>\n<span class="sep">|</span>\n<a href="stream.html\?channel=
#line 209 "stream.ecpp"
  reply.sout() << ( (Channel->Number() + 1) );
  reply.out() << data[33]; // ">Next \302\273</a>\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
