////////////////////////////////////////////////////////////////////////
// stream_data.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.stream_data")

// <%pre>
#line 1 "stream_data.ecpp"


#include <filecache.h>
#include <tntfeatures.h>
#include <ffmpeg.h>
#include <fstream>
#include <tnt/mimedb.h>
#include <tnt/sessionunlocker.h>

#include <vdr/tools.h>
#include <unistd.h>

using namespace std;
using namespace vdrlive;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("stream_data");

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("stream_data " << qparam.getUrl());


#line 18 "stream_data.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 19 "stream_data.ecpp"
  typedef FFmpegThread * f_worker_type;
  TNT_SESSION_GLOBAL_VAR(f_worker_type, f_worker, "FFmpegThread * f_worker", ( NULL));   // <%session> FFmpegThread * f_worker( NULL)
  // <%cpp>
#line 21 "stream_data.ecpp"

if(f_worker) f_worker->Touch();
tnt::SessionUnlocker unlck = tnt::SessionUnlocker(request, true);

reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");

// assign Mime type to repply
tnt::MimeDb mimeDb("/etc/mime.types");
string mime = mimeDb.getMimetype(request.getPathInfo());
reply.setContentType(mime);

// check for session cookie. TODO: handle secure cookie for ssl
string session;
if (request.hasCookie("tntnet")) {
	session = request.getCookie("tntnet");
}

// forge target path from requested path.
string path(request.getPathInfo());
if (path.substr(0, 7) == "/media/") {
	path.replace(0, 7, "/tmp/live-hls-buffer/");
}
else return DECLINED;

// try to open the target file
uint8_t retry;
if (path.rfind(".m3u8") != string::npos && path.find("master_") != string::npos) retry = 100;
else retry = 5;
std::ifstream f;
do {
	f.open ( path.c_str(), std::ios::binary );
	if (!f.is_open()) {
		usleep(200e3);
	}
} while (!f.is_open() && --retry);

// fail if file did not appear
if (!f.is_open()) {
	dsyslog("vdrlive::stream_data: DECLINED");
	return DECLINED;
}

// wait until TARGETDURATION in playlist is != 0
if (path.rfind(".m3u8") != string::npos && path.find("ffmpeg_") != string::npos) {
	string line;
	int count = 20;
	while(getline(f, line) && count) {
		if (string::npos != line.find("#EXT-X-TARGETDURATION:")) {
			if (! (atoi(line.erase(0, 22).c_str()))) {
				count--;
				f.close();
				usleep(100e3);
				f.open( path.c_str(), std::ios::binary );
			}
		}
	}
	f.clear(); // unset eof flag
}

usleep(100e3);
f.seekg( 0, std::ios::end );
streamsize size = f.tellg();
f.seekg( 0, std::ios::beg );

unsigned httpReturn = HTTP_OK;
string range = request.getHeader(tnt::httpheader::range);
off_t offset = 0, stop = size-1;
if (!range.empty()) {
	range.erase(0,6);
	stringstream ss(range);
	char tmp;
	ss >> offset >> tmp >> stop;
	dsyslog("vdrlive::stream_data::range(%ld to %ld)", offset, stop);
	if (offset > size) return HTTP_RANGE_NOT_SATISFIABLE;
	if ((stop+1) > size) stop = size - 1;
	httpReturn = HTTP_PARTIAL_CONTENT;
	ostringstream contentRange;
	contentRange << offset << ('-') << stop << ('/') << size;
	reply.setHeader(tnt::httpheader::contentRange, contentRange.str());
	f.seekg( offset, std::ios::beg );
}

char buffer[KILOBYTE(64)];
streamsize r, c = stop - offset+ 1;
while (r = f.readsome(buffer, (c < (long int) sizeof(buffer))?c:sizeof(buffer))) {
	reply.out().write(buffer, r);
	c -= r;
	if (!reply.out()) {
		return HTTP_GONE;
	}
#if TNT_WATCHDOG_SILENCE
	request.touch(); // retrigger the watchdog.
#endif
}

reply.out() << std::flush;
return httpReturn;

  // <%/cpp>
  return HTTP_OK;
}

} // namespace
